import pygame, spriteloader, inanimate, display

class Door(inanimate.inanimate):
    def __init__(self,location):
        self.image = pygame.image.load("door.gif")
        self.image.set_colorkey((0,0,0))
        self.location = location
        self.sprites = spriteloader.get_sprites(self.image,32,32)
        for f in self.sprites:
            f.set_colorkey((254,254,254))
        self.frame = 0
        self.num_frames = 4
        self.closed = True
    def colliderect(self, other):
        colliding = self.location.colliderect(other)
        if colliding:
            self.closed = False
        return colliding
    def is_solid(self):
        return False
    def draw(self,screen, screen_rect):
        if display.is_on_screen(self.location,screen_rect):
            if self.closed:
                screen.blit(self.sprites[0], display.abs_to_screen(self.location,screen_rect))
            else:
                screen.blit(self.sprites[3], display.abs_to_screen(self.location,screen_rect)) 
        

