class inanimate:
    """
    Base class for inanimate objects
    """
    def draw(self,screen,screen_rect):
        """
        Draw the item to the screen. 
        screen_rect is the current viewing window in abs coordinates
        """
        return
    def colliderect(self,rect):
        """
        Returns if the inanimate oject is colliding with something(using rect collision)
        """
        return False
    def touched_from_top(self,knight):
        """
        Called when the knight collides with the inanimate object from above
        """
        return
    def touched_from_bottom(self,knight):
        """
        Called when the knight collides with the inanimate object from below
        """
        return
    def touched_from_left(self,knight):
        """
        Called when the knight collides with the inanimate object from the left
        """
        return
    def touched_from_right(self,knight):
        """
        Called when the knight collides with the inanimate object from the right
        """
        return
    def is_solid(self):
        """
        Returns if the inanimate object is solid(meaning animate objects cannot walk through it)
        """
        return False
